﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// See https://mathworld.wolfram.com/Multifactorial.html

namespace howto_multifactorials
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void btnCalculate_Click(object sender, EventArgs e)
        {
            int n = int.Parse(txtN.Text);
            lstMultiFactorials.Items.Clear();

            // Factorial.
            for (int f = 1; f < n; f++)
            {
                string s = n.ToString() +
                    new String('!', f) +
                    " = " +
                    n.ToString();
                long value = n;
                for (int i = n - f; i > 0; i -= f)
                {
                    s += " × " + i.ToString();
                    value *= i;
                }
                s += " = " + value.ToString("n0");
                lstMultiFactorials.Items.Add(s);
            }
        }
    }
}
